var currentUserId = null;

function setLoggedIn(userId) {
	currentUserId = userId;
	if (userId !== null) {
		$('.pre_login').hide();
		$('.post_login').show();
	} else {
		$('.post_login').hide();
		$('.pre_login').show();
	}
}

$(document).ready(function() {
	dust.render('login_dialog', {}, function (err, out) {
		if (err) {
			console.log(err.message || err);
		}
		if (out) {
			$('body').append(out);
			configureLoginDialog();
		}
	});

	dust.render('register_dialog', {}, function (err, out) {
		if (err) {
			console.log(err.message || err);
		}
		if (out) {
			$('body').append(out);
			configureRegisterDialog();
		}
	});

	$(document).on('click', '#login', function (evnt) {
		evnt.preventDefault();
		setLoggedIn(null);
		$('#login_dialog').dialog('open');
	});

	$(document).on('click', '#register', function (evnt) {
		evnt.preventDefault();
		setLoggedIn(null);
		$('#register_dialog').dialog('open');
	});

	$(document).on('click', '#logout', function (evnt) {
		evnt.preventDefault();
		setLoggedIn(null);
		$.ajax({ url: '/logout', type: 'post', cache: false });
	});

	function configureLoginDialog() {
		$('#login_dialog').dialog({
			autoOpen: false,
			model: true,
			buttons: {
				"Log In": handleLoginRequest,
				"Cancel": function () {
					$('#login_dialog').dialog('close');
				}
			},
			close: function () {
				$('#login_dialog input').val('');
				$('#login_error').empty().hide();
			}
		});
	}

	function handleLoginRequest() {
		$.ajax({ url: '/login', type: 'post', cache: false,
			data: { login: $('#login_login').val(),
				password: $('#login_password').val() },
			error: function (jqxhr, textStatus) {
				$('#login_error').text('HTTP error: ' + textStatus).show();
			},
			success: function (jsonData) {
				if (jsonData.ok) {
					setLoggedIn(jsonData.userid);
					$('#login_dialog').dialog('close');
				} else {
					$('#login_error').text(jsonData.message).show();
				}
			}
		});
	}

	function configureRegisterDialog() {
		$('#register_dialog').dialog({
			autoOpen: false,
			model: true,
			buttons: {
				"Register": handleRegisterRequest,
				"Cancel": function () {
					$('#register_dialog').dialog('close');
				}
			},
			close: function () {
				$('#register_dialog input').val('');
				$('#register_error').empty().hide();
			}
		});
	}

	function handleRegisterRequest() {
		$.ajax({ url: '/register', type: 'post', cache: false,
			data: { login: $('#register_login').val(),
				password: $('#register_password').val(),
				firstname: $('#register_firstname').val(),
				lastname: $('#register_lastname').val(),
				},
			error: function (jqxhr, textStatus) {
				$('#register_error').text('HTTP error: ' + textStatus).show();
			},
			success: function (jsonData) {
				if (jsonData.ok) {
					setLoggedIn(jsonData.userid);
					$('#register_dialog').dialog('close');
				} else {
					$('#register_error').text(jsonData.message).show();
				}
			}
		});
	}

	// This just has to be once - it makes it so pressing Enter while in
	// a dialog's text field triggers the first button in the dialog
	$(document).delegate('.ui-dialog', 'keyup', function(e) {
        var tagName = e.target.tagName.toLowerCase();
        tagName = (tagName === 'input' && e.target.type === 'button') ?
			'button' : tagName;
        if (e.which === $.ui.keyCode.ENTER && tagName !== 'textarea' &&
				tagName !== 'select' && tagName !== 'button') {
            $(this).find('.ui-dialog-buttonset button').eq(0).trigger('click');
            return false;
        }
    });
});
